from emod_api import schema_to_class as s2c
import emod_api.interventions.common as common
import emod_api.interventions.utils as utils
from emodpy_tbhiv.interventions import purge_campaign_event

def HSB(
        camp,
        trigger_treatment_list,
        output_event,
        probability_per_step=1.0, 
        start_day=0,
        duration=-1,
        property_restrictions_list=[],
        nodeIDs=[],
        black_period=0,
        black_trigger='Blackout',
        event_name='HSB'):
    """
    HSB
    :param TBD
    Note start_day is initialized as 1, recommend that this be aligned with the start of the simulation
    """
    schema_path = camp.schema_path
    intervention = s2c.get_class_with_defaults( "SimpleHealthSeekingBehavior", schema_path )
    intervention.Event_Or_Config = 'Event'
    intervention.Actual_IndividualIntervention_Event = camp.get_send_trigger(output_event)
    intervention.Tendency = probability_per_step

    event = common.TriggeredCampaignEvent( camp, start_day,event_name, trigger_treatment_list, [ intervention ], Nodeset_Config=utils.do_nodes( camp.schema_path, nodeIDs ), Duration=duration, Property_Restrictions=property_restrictions_list )
    purge_campaign_event( event )
    return event

def new_intervention_as_file( camp, filename="hsb_diag.json" ):
    camp.add( HSB( camp, trigger_treatment_list=[ "Births" ], output_event="Seeking" ) ) 
    camp.save( filename )
    return filename

